# -*- coding:utf-8 -*-
from django.db import models

class Sequence(models.Model):
    value = models.DecimalField(max_digits=14, decimal_places=2)
    def __unicode__(self):
        return unicode(self.value)
    
class Whole(models.Model):
    total_value = models.DecimalField(max_digits=14, decimal_places=2)
    def __unicode__(self):
        aggregation = sum([p.after.value - p.before.value for p in Part.objects.filter(whole=self)])
        equals = '=' if aggregation == self.total_value else '!='
        return "total: {} {} [{}]".format(self.total_value, equals, ' + '.join(
            [str(p.after.value - p.before.value) for p in Part.objects.filter(whole=self)]
        ))
    
class Part(models.Model):
    whole = models.ForeignKey(Whole)
    before = models.ForeignKey(Sequence, related_name="+")
    after = models.ForeignKey(Sequence, related_name="+")
    def __unicode__(self):
        return "{} to {} ({}) - part of {}".format(self.before.value, 
                                                   self.after.value, 
                                                   self.after.value-self.before.value, 
                                                   self.whole.total_value)
    
